
let context = document.getElementsByTagName('canvas')[0].getContext('2d');

let gow = context.canvas.width;
let goh = context.canvas.height;
let giw = gow - 40;
let gih = goh - 30;
let gix = 25;
let giy = 10;
let repeat = 1;
let sw_data = 0;
let	select_no = 0;
let message = "";
let regist = 1;
let save_white_dark = 1;
let up_down	= 1;
let disp_kind = "data";
let jsonname = "";
let	tm = "";

const	sw_up1 = 1;
const	sw_up2 = 2;
const	sw_down1 = 3;
const	sw_down2 = 4;
const	sw_state = 5;
const	sw_mode = 6;
const	sw_disp = 7;
const	sw_white_set = 8;
const	sw_white_clear = 9;
const	sw_dark_set = 10;
const	sw_dark_clear = 11;
const	sw_ref1	= 12;
const	sw_ref2	= 13;
const	sw_ref3	= 14;
const	sw_ref4	= 15;
const	sw_ref5	= 16;
const	sw_ref6	= 17;
const	sw_save = 18;

let w_set = document.getElementById('w_set');
let w_clr = document.getElementById('w_clr');
let d_set = document.getElementById('d_set');
let d_clr = document.getElementById('d_clr');

let ref = document.getElementById('ref');
let ref1 = document.getElementById('ref1');
let ref2 = document.getElementById('ref2');
let ref3 = document.getElementById('ref3');
let ref4 = document.getElementById('ref4');
let ref5 = document.getElementById('ref5');
let ref6 = document.getElementById('ref6');

let up1 = document.getElementById('up1');
let up2 = document.getElementById('up2');
let down1 = document.getElementById('down1');
let down2 = document.getElementById('down2');

let config = document.getElementById('config');
let mode = document.getElementById('mode');
let disp = document.getElementById('disp');
let state = document.getElementById('state');
let save = document.getElementById('save');

let calcdata = document.getElementById('calc');

w_set.onclick = w_setClicked;
w_clr.onclick = w_clrClicked;
d_set.onclick = d_setClicked;
d_clr.onclick = d_clrClicked;

ref1.onclick = ref1Clicked;
ref2.onclick = ref2Clicked;
ref3.onclick = ref3Clicked;
ref4.onclick = ref4Clicked;
ref5.onclick = ref5Clicked;
ref6.onclick = ref6Clicked;

up1.onclick	= up1Clicked;
up2.onclick	= up2Clicked;
down1.onclick	= down1Clicked;
down2.onclick	= down2Clicked;

mode.onclick = modeClicked;
disp.onclick = dispClicked;
state.onclick = stateClicked;
save.onclick = saveClicked;


let	interval;
let bar;
let rgb_table  = [
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#0F001C","#0F001C","#0F001C","#0F001C","#0F001C",
	"#16002A","#16002A","#16002A","#16002A","#16002A",
	"#230043","#230043","#230043","#230043","#230043",
	"#340065","#340065","#340065","#340065","#340065",
	"#4F009A","#4F009A","#4F009A","#4F009A","#4F009A",
	"#6500CD","#6500CD","#6500CD","#6500CD","#6500CD",
	"#6700DF","#6700DF","#6700DF","#6700DF","#6700DF",
	"#5700E0","#5700E0","#5700E0","#5700E0","#5700E0",
	"#1C00DB","#1C00DB","#1C00DB","#1C00DB","#1C00DB",
	"#0026C6","#0026C6","#0026C6","#0026C6","#0026C6",
	"#0062A6","#0062A6","#0062A6","#0062A6","#0062A6",
	"#007E84","#007E84","#007E84","#007E84","#007E84",
	"#009766","#009766","#009766","#009766","#009766",
	"#00B141","#00B141","#00B141","#00B141","#00B141",
	"#00C600","#00C600","#00C600","#00C600","#00C600",
	"#00D000","#00D000","#00D000","#00D000","#00D000",
	"#00D200","#00D200","#00D200","#00D200","#00D200",
	"#00CF00","#00CF00","#00CF00","#00CF00","#00CF00",
	"#78C500","#78C500","#78C500","#78C500","#78C500",
	"#B2B600","#B2B600","#B2B600","#B2B600","#B2B600",
	"#D89F00","#D89F00","#D89F00","#D89F00","#D89F00",
	"#F17E00","#F17E00","#F17E00","#F17E00","#F17E00",
	"#FE4F00","#FE4F00","#FE4F00","#FE4F00","#FE4F00",
	"#FF0000","#FF0000","#FF0000","#FF0000","#FF0000",
	"#F30000","#F30000","#F30000","#F30000","#F30000",
	"#DC0000","#DC0000","#DC0000","#DC0000","#DC0000",
	"#C20000","#C20000","#C20000","#C20000","#C20000",
	"#A40000","#A40000","#A40000","#A40000","#A40000",
	"#860000","#860000","#860000","#860000","#860000",
	"#6A0000","#6A0000","#6A0000","#6A0000","#6A0000",
	"#540000","#540000","#540000","#540000","#540000",
	"#400000","#400000","#400000","#400000","#400000",
	"#320000","#320000","#320000","#320000","#320000",
	"#270000","#270000","#270000","#270000","#270000",
	"#1E0000","#1E0000","#1E0000","#1E0000","#1E0000",
	"#170000","#170000","#170000","#170000","#170000",
	"#110000","#110000","#110000","#110000","#110000",
	"#0D0000","#0D0000","#0D0000","#0D0000","#0D0000",
	"#0A0000","#0A0000","#0A0000","#0A0000","#0A0000",
	"#090002","#090002","#090002","#090002","#090002",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
	"#000000","#000000","#000000","#000000","#000000",
			];
  
function dummy( data)
{
	message = data.msg;
	setTimeout(() => {
		get_data();
	}, 100);
}

function up1Clicked(){
	if( up_down){
		sw_data = sw_up1;
	}
}

function up2Clicked(){
	if( up_down){
		sw_data = sw_up2;
	}
}

function down1Clicked(){
	if( up_down){
		sw_data = sw_down1;
	}
}

function down2Clicked(){
	if( up_down){
		sw_data = sw_down2;
	}
}

function stateClicked(){
	if( disp_kind != "ref"){
		sw_data = sw_state;
	}
}

function saveClicked(){
	if( save_white_dark){
		sw_data = sw_save;
	}
}

function w_setClicked(){
	if( save_white_dark){
		if(window.confirm( "white set")){
			sw_data = sw_white_set;
		}
	}
}

function w_clrClicked(){
	if( save_white_dark){
		if(window.confirm( "white clear")){
			sw_data = sw_white_clear;
		}
	}
}

function d_setClicked(){
	if( save_white_dark){
		if(window.confirm( "dark set")){
			sw_data = sw_dark_set;
		}
	}
}

function d_clrClicked(){
	if( save_white_dark){
		if(window.confirm( "dark clear")){
			sw_data = sw_dark_clear;
		}
	}
}

function modeClicked(){
	sw_data = sw_mode;
}

function dispClicked(){
	sw_data = sw_disp;
}
	

function ref1Clicked(){
	if( regist){
		if( window.confirm( "regist #1")){
			sw_data = sw_ref1;
		}
	} else {
		sw_data = sw_ref1;
	}
}

function ref2Clicked(){
	if( regist){
		if( window.confirm( "regist #2")){
			sw_data = sw_ref2;
		}
	} else {
		sw_data = sw_ref2;
	}
}

function ref3Clicked(){
	if( regist){
		if( window.confirm( "regist #3")){
			sw_data = sw_ref3;
		}
	} else {
		sw_data = sw_ref3;
	}
}

function ref4Clicked(){
	if( regist){
		if( window.confirm( "regist #4")){
			sw_data = sw_ref4;
		}
	} else {
		sw_data = sw_ref4;
	}
}

function ref5Clicked(){
	if( regist){
		if( window.confirm( "regist #5")){
			sw_data = sw_ref5;
		}
	} else {
		sw_data = sw_ref5;
	}
}

function ref6Clicked(){
	if( regist){
		if( window.confirm( "regist #6")){
			sw_data = sw_ref6;
		}
	} else {
		sw_data = sw_ref6;
	}
}


function frame( pixel) {
	let i;
	context.save();
	context.beginPath();

	blankall();
	context.fillStyle	= 'black';
	context.fillRect( gix-1, giy-1, 1, gih+2);						// line
	context.fillRect( gix+giw, giy-1, 1, gih+2);					// line
	context.fillRect( gix-1, giy-1, giw+2, 1);						// line
	context.fillRect( gix-1, giy+gih, giw+2, 1);					// line
	if( pixel.mode == "raw"){
		for( i = 0 ; i <= 100; i += 10){
			context.fillText( i.toString(), gix - 20, giy + gih + 5 - i*gih/100 );	// left number
		}
	} else {
		for( i = 0 ; i <= 100; i += 10){
			context.fillText( (i/50).toString(), gix - 20, giy + gih + 5 - i*gih/100 );	// left number
		}
	}
	for( i = 350 ; i <= 850; i += 50){
		context.fillText( i.toString(), gix-5+(i-340-5) /2, giy + gih + 10 );	// wave number
	}
	context.fillStyle	= 'gray';
	for( i = 10 ; i <= 90; i += 10){
		context.fillRect( gix, giy+gih-i*gih/100, giw, 1);
	}
	for( i = 350 ; i <= 850; i += 50){
		context.fillRect( gix+(i-340) /2, giy, 1, gih);
	}
	context.stroke();
	context.restore();
}

function blankall() {
	context.fillStyle = 'rgba(255,255,192,1)';
	context.fillRect( 0, 0, gow, goh);
	context.stroke();
	context.restore();
}
		
function blankgi() {
	context.fillStyle = 'rgba(255,255,192,1)';
	context.fillRect(gix+1, giy+1, giw-2, gih-2);
	context.stroke();
}

function get_data(){
	fetch( "./data/data.json")
	.then( response => response.json())
	.then( data => graph( data) )
	.catch((reason) => {
		console.log( reason);
		context.fillStyle	= 'red';
		context.fillText( "data error", gix+giw/2-50, giy+gih/2 );
		context.stroke();
		context.restore();
		});
}

function kick_data(){
	fetch( "./data/start.json")
	.then( response => response.json())
	.then( data => dummy( data) )
	.catch((reason) => {
		console.log( reason);
		context.fillStyle	= 'red';
		context.fillText( "start error", gix+giw/2-50, giy+gih/2 );
		context.stroke();
		context.restore();
		});
}

function save_csv( pixel)
{
	let i;
	let dt = new Date();
	const fileName = dt.getFullYear().toString() + (dt.getMonth()+1).toString() + dt.getDate().toString() + "_"+dt.getHours().toString()+dt.getMinutes().toString()+dt.getSeconds().toString()+".csv";
	var str;
	str = "date,time,temp";
	for( i = 340; i < 852; i+=2){
		str += "," + i.toString();
	}
	str += "\n";
	str += dt.getFullYear().toString();
	str += "/" + (dt.getMonth()+1).toString();
	str += "/" + dt.getDate().toString();
	str += "," + dt.getHours().toString();
	str += ":" + dt.getMinutes().toString();
	str += ":" + dt.getSeconds().toString();
	str += "," + pixel.t.toString();
	for( i = 0; i < pixel.n; i++){
		str += ",";
		str += pixel.d[ i].toString();
	}
	str += "\n";
	var blob =new Blob([str],{type:"text/csv"});
	var link =document.createElement('a');
	link.href = URL.createObjectURL(blob);
	link.download = fileName;
	link.click();
}

function save_jason( pixel)
{
	const fileName = pixel.month.toString() + pixel.date.toString() + "_"+pixel.hour.toString()+pixel.min.toString()+pixel.sec.toString()+".json";
	const data = JSON.stringify(pixel);
	const blob = new Blob([data], { type: 'application/json' });
	const link = document.createElement("a");
	link.href = window.URL.createObjectURL(blob);
	link.download = fileName;
	link.click();
	
}

function errorFunc( error )
{
	var errorMessage = {
		0: "no reason" ,
		1: "cannot get permission" ,
		2: "week wave" ,
		3: "time out" ,
	} ;
	alert( errorMessage[error.code] ) ;
}

function set_ref_button( no)
{
	ref1.style.backgroundColor = "#3f4811";
	ref2.style.backgroundColor = "#3f4811";
	ref3.style.backgroundColor = "#3f4811";
	ref4.style.backgroundColor = "#3f4811";
	ref5.style.backgroundColor = "#3f4811";
	ref6.style.backgroundColor = "#3f4811";
	if( regist == 0){
		if( no ==1) {
			ref1.style.backgroundColor = "#3fb811";
		} else if( no == 2){
			ref2.style.backgroundColor = "#3fb811";
		} else if( no == 3){
			ref3.style.backgroundColor = "#3fb811";
		} else if( no == 4){
			ref4.style.backgroundColor = "#3fb811";
		} else if( no == 5){
			ref5.style.backgroundColor = "#3fb811";
		} else if( no == 6){
			ref6.style.backgroundColor = "#3fb811";
		}
	}
}

function set_swd_button( ena)
{
	if( ena){
		save.style.backgroundColor = "#ff0000";
		w_set.style.backgroundColor = "#0000ff";
		w_clr.style.backgroundColor = "#0000ff";
		d_set.style.backgroundColor = "#0000ff";
		d_clr.style.backgroundColor = "#0000ff";
	} else {
		save.style.backgroundColor = "#808080";
		w_set.style.backgroundColor = "#808080";
		w_clr.style.backgroundColor = "#808080";
		d_set.style.backgroundColor = "#808080";
		d_clr.style.backgroundColor = "#808080";
	}
}

function set_ud_button( ena)
{
	if( ena){
		up1.style.backgroundColor = "#10cf10";
		up2.style.backgroundColor = "#10cf10";
		down1.style.backgroundColor = "#10cf10";
		down2.style.backgroundColor = "#10cf10";
	} else {
		up1.style.backgroundColor = "#808080";
		up2.style.backgroundColor = "#808080";
		down1.style.backgroundColor = "#808080";
		down2.style.backgroundColor = "#808080";
	}
}

function set_disp_button( kind)
{
	if( kind == "data"){
		disp.style.backgroundColor = "#10cf10";
		disp.textContent = "DATA";
	} else if( kind == "comp"){
		disp.style.backgroundColor = "#808010";
		disp.textContent = "COMP";
	} else {
		disp.style.backgroundColor = "#108080";
		disp.textContent = "REF+";
	}
}

function set_state_button( kind)
{
	if( kind == "ref"){
		state.style.backgroundColor = "#808080";
	} else {
		state.style.backgroundColor = "#108010";
	}
}

function set_mode_button( kind)
{
	if( kind == "raw"){
		mode.style.backgroundColor = "#408080";
		mode.textContent = "R A W";
	} else {
		mode.style.backgroundColor = "#808040";
		mode.textContent = "reflect";
	}
}
function graph( pixel) {
	let i;
	let h;
	let d;
	let no;
	let n;
	let date;
	let time;
	let xs;
	let ys;
	let old;
	let dt = new Date();
	frame( pixel);
	if( pixel.n > 0){
		date = dt.getFullYear().toString()+"/"+(dt.getMonth()+1).toString()+"/"+dt.getDate().toString();
		time = dt.getHours().toString()+":"+dt.getMinutes().toString()+":"+dt.getSeconds().toString();
		tm = date + " " + time;
		if( pixel.disp == "data"){
			ref.textContent = "regist";
			regist = 1;
			save_white_dark = 1;
		} else {
			ref.textContent = "select";
			regist = 0;
			save_white_dark = 0;
		}
		set_ref_button( select_no);
		set_swd_button( save_white_dark);
		if( pixel.disp == "ref"){
			up_down = 0;
		} else {
			up_down = 1;
		}
		set_ud_button( up_down);
		set_disp_button( pixel.disp);
		set_state_button( pixel.disp);
		set_mode_button( pixel.mode);
		disp_kind = pixel.disp;
		select_no = pixel.c;

		if( pixel.n < 256){
			n = pixel.n;
		} else {
			n = 256;
		}
		old = 0;
		for(i = 0 ; i < n; i++){
			if( pixel.mode == "raw"){
				d = pixel.r[ i]*gih/65535;
			} else {
				d = pixel.r[ i]*gih/2;
			}
			if( d < gih){
				h = d;
			} else {
				h = gih;
			}
			if( pixel.disp == "comp"){
				context.fillStyle = rgb_table[0];
				if( h > old){
					context.fillRect( gix+i, giy+gih-h, 1, h - old);
				} else if( h < old){
					context.fillRect( gix+i-1, giy+gih-old, 1, old - h -1);
					context.fillRect( gix+i, giy+gih-h, 1, 1);
				} else {
					context.fillRect( gix+i, giy+gih-h, 1, 1);
				}
				old = h;
			} else if( pixel.disp == "ref"){
				context.fillStyle = rgb_table[i];
				context.fillRect( gix+i, giy+gih-h, 1, h);
			}
		}
		old = 0;
		for(i = 0 ; i < n; i++){
			context.fillStyle = rgb_table[i];
			if( pixel.mode == "raw"){
				d = pixel.d[ i]*gih/65535;
			} else {
				d = pixel.d[ i]*gih/2;
			}
			if( d < gih){
				h = d;
			} else {
				h = gih;
			}
			if( pixel.disp == "comp"){
				if( h > old){
					context.fillRect( gix+i, giy+gih-h, 1, h - old);
				} else if( h < old) {
					context.fillRect( gix+i-1, giy+gih-old, 1, old - h-1);
					context.fillRect( gix+i, giy+gih-h, 1, 1);
				} else {
					context.fillRect( gix+i, giy+gih-h, 1, 1);
				}
				old = h;
			} else if( pixel.disp == "data"){
				context.fillRect( gix+i, giy+gih-h, 1, h);
			}
		}
		if( pixel.save){
			save_csv( pixel);
		}
		repeat = pixel.repeat;
		xs = 5;
		ys = 10;
		context.fillStyle = 'blue';
		if( pixel.disp == "data"){
			context.fillText( "Exposure(us)="+pixel.e.toString(), gix + xs, giy + ys );	ys += 14;
		} else if( pixel.disp == "comp"){
			context.fillText( "Exposure(us)="+pixel.e.toString()+ "/"+pixel.f.toString(), gix + xs, giy + ys );	ys += 14;
		} else {
			context.fillText( "registered="+pixel.tm, gix + xs, giy + ys );	ys += 14;
			context.fillText( "Exposure(us)="+pixel.f.toString(), gix + xs, giy + ys );	ys += 14;
		}
		context.fillText( "average num ="+pixel.a.toString(), gix + xs, giy + ys );	ys += 14;
		context.fillText( "temp        ="+pixel.t.toString(), gix + xs, giy + ys );	ys += 14;
		context.fillText( "bat voltage ="+pixel.v.toString(), gix + xs, giy + ys );	ys += 14;
		if( repeat){
			context.fillText( "state   =monitoring", gix + xs, giy + ys );ys += 14;
		} else {
			context.fillText( "state   =stopped", gix + xs, giy + ys );ys += 14;
		}
	} else {
		context.fillStyle = 'red';
		context.fillText( " no data ", gix +55, giy + 30 );	// no data
	}
	context.stroke();
	context.restore();
	if( message != ""){
		context.fillStyle = 'blue';
		context.fillText( message, gix+giw/2-50, giy+gih/2);
		next_data(500);
		message = "";
	} else {
		next_data(100);
	}
	calcdata.innerText = pixel.msg;
}

function	next_data(  dly)
{
	if( sw_data == 0){
		if( repeat){
			setTimeout(() => {
				get_data();
			}, dly);
		} else {
			sleep_a_little();
		}
	} else {
		if( sw_data == sw_up1){
			fetch( "./data/up1.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "up1 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_up2){
			fetch( "./data/up2.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "up2 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_down1){
			fetch( "./data/down1.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "down1 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_down2){
			fetch( "./data/down2.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "down2 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_state){
			fetch( "./data/repeat.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "repeat error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_save){
			fetch( "./data/save.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "save error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_mode){
			fetch( "./data/mode.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "dark clear error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_disp){
			fetch( "./data/disp.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "disp error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_white_set){
			fetch( "./data/wset.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "white set error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_white_clear){
			fetch( "./data/wclear.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "white clear error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_dark_set){
			fetch( "./data/dset.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "dark set error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_dark_clear){
			fetch( "./data/dclear.json")
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "dark clear error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref1){
			jsonname = "./data/ref1.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #1 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref2){
			jsonname = "./data/ref2.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #2 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref3){
			jsonname = "./data/ref3.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #3 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref4){
			jsonname = "./data/ref4.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #4 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref5){
			jsonname = "./data/ref5.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #5 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		} else if( sw_data == sw_ref6){
			jsonname = "./data/ref6.json?s="+tm;
			fetch( jsonname)
			.then( response => response.json())
			.then( data => dummy( data) )
			.catch((reason) => {
				console.log( reason);
				context.fillStyle	= 'red';
				context.fillText( "ref #6 error", gix+giw/2-50, giy+gih/2 );	// error message
				context.stroke();
				context.restore();
			});
		}
		sw_data = 0;
	}
}

function	sleep_a_little( )
{
	setTimeout(() => {
		next_data( 500);
	}, 100);
}

function	start_data( )
{
	setTimeout(() => {
		kick_data();
	}, 500);
}
start_data();

